Index: uspace/srv/vfs/vfs_ipc.c
===================================================================
--- uspace/srv/vfs/vfs_ipc.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
+++ uspace/srv/vfs/vfs_ipc.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -0,0 +1,326 @@
+/*
+ * Copyright (c) 2008 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include "vfs.h"
+
+#include <errno.h>
+#include <stdlib.h>
+#include <str.h>
+#include <vfs/canonify.h>
+
+static void vfs_in_clone(ipc_callid_t rid, ipc_call_t *request)
+{
+	int oldfd = IPC_GET_ARG1(*request);
+	int newfd = IPC_GET_ARG2(*request);
+	bool desc = IPC_GET_ARG3(*request);
+	
+	int ret = vfs_op_clone(oldfd, newfd, desc);
+	async_answer_0(rid, ret);
+}
+
+static void vfs_in_mount(ipc_callid_t rid, ipc_call_t *request)
+{
+	int mpfd = IPC_GET_ARG1(*request);
+	
+	/*
+	 * We expect the library to do the device-name to device-handle
+	 * translation for us, thus the device handle will arrive as ARG1
+	 * in the request.
+	 */
+	service_id_t service_id = (service_id_t) IPC_GET_ARG2(*request);
+	
+	unsigned int flags = (unsigned int) IPC_GET_ARG3(*request);
+	unsigned int instance = IPC_GET_ARG4(*request);
+	
+	char *opts = NULL;
+	char *fs_name = NULL;
+	
+	/* Now we expect to receive the mount options. */
+	int rc = async_data_write_accept((void **) &opts, true, 0,
+	    MAX_MNTOPTS_LEN, 0, NULL);
+	if (rc != EOK) {
+		async_answer_0(rid, rc);
+		return;
+	}
+	
+	/* Now, we expect the client to send us data with the name of the file 
+	 * system.
+	 */
+	rc = async_data_write_accept((void **) &fs_name, true, 0,
+	    FS_NAME_MAXLEN, 0, NULL);
+	if (rc != EOK) {
+		free(opts);
+		async_answer_0(rid, rc);
+		return;
+	}
+	
+	int outfd = 0;
+	rc = vfs_op_mount(mpfd, service_id, flags, instance, opts, fs_name,
+	     &outfd);
+	async_answer_1(rid, rc, outfd);
+	
+	free(opts);
+	free(fs_name);
+}
+
+static void vfs_in_open(ipc_callid_t rid, ipc_call_t *request)
+{
+	int fd = IPC_GET_ARG1(*request);
+	int mode = IPC_GET_ARG2(*request);
+
+	int rc = vfs_op_open(fd, mode);
+	async_answer_0(rid, rc);
+}
+
+static void vfs_in_put(ipc_callid_t rid, ipc_call_t *request)
+{
+	int fd = IPC_GET_ARG1(*request);
+	int rc = vfs_op_put(fd);
+	async_answer_0(rid, rc);
+}
+
+static void vfs_in_read(ipc_callid_t rid, ipc_call_t *request)
+{
+	int fd = IPC_GET_ARG1(*request);
+	aoff64_t pos = MERGE_LOUP32(IPC_GET_ARG2(*request),
+	    IPC_GET_ARG3(*request));
+
+	size_t bytes = 0;
+	int rc = vfs_op_read(fd, pos, &bytes);
+	async_answer_1(rid, rc, bytes);
+}
+
+static void vfs_in_rename(ipc_callid_t rid, ipc_call_t *request)
+{
+	/* The common base directory. */
+	int basefd;
+	char *old = NULL;
+	char *new = NULL;
+	int rc;
+	
+	basefd = IPC_GET_ARG1(*request);
+	
+	/* Retrieve the old path. */
+	rc = async_data_write_accept((void **) &old, true, 0, 0, 0, NULL);
+	if (rc != EOK)
+		goto out;
+	
+	/* Retrieve the new path. */
+	rc = async_data_write_accept((void **) &new, true, 0, 0, 0, NULL);
+	if (rc != EOK)
+		goto out;
+	
+	size_t olen;
+	size_t nlen;
+	char *oldc = canonify(old, &olen);
+	char *newc = canonify(new, &nlen);
+	
+	if ((!oldc) || (!newc)) {
+		rc = EINVAL;
+		goto out;
+	}
+	
+	assert(oldc[olen] == '\0');
+	assert(newc[nlen] == '\0');
+	
+	rc = vfs_op_rename(basefd, oldc, newc);
+
+out:
+	async_answer_0(rid, rc);
+
+	if (old)
+		free(old);
+	if (new)
+		free(new);
+}
+
+static void vfs_in_resize(ipc_callid_t rid, ipc_call_t *request)
+{
+	int fd = IPC_GET_ARG1(*request);
+	int64_t size = MERGE_LOUP32(IPC_GET_ARG2(*request), IPC_GET_ARG3(*request));
+	int rc = vfs_op_resize(fd, size);
+	async_answer_0(rid, rc);
+}
+
+static void vfs_in_stat(ipc_callid_t rid, ipc_call_t *request)
+{
+	int fd = IPC_GET_ARG1(*request);
+	int rc = vfs_op_stat(fd);
+	async_answer_0(rid, rc);
+}
+
+static void vfs_in_statfs(ipc_callid_t rid, ipc_call_t *request)
+{
+	int fd = (int) IPC_GET_ARG1(*request);
+	
+	int rc = vfs_op_statfs(fd);
+	async_answer_0(rid, rc);
+}
+
+static void vfs_in_sync(ipc_callid_t rid, ipc_call_t *request)
+{
+	int fd = IPC_GET_ARG1(*request);
+	int rc = vfs_op_sync(fd);
+	async_answer_0(rid, rc);
+}
+
+static void vfs_in_unlink(ipc_callid_t rid, ipc_call_t *request)
+{
+	int parentfd = IPC_GET_ARG1(*request);
+	int expectfd = IPC_GET_ARG2(*request);
+	
+	char *path;
+	int rc = async_data_write_accept((void **) &path, true, 0, 0, 0, NULL);
+	if (rc == EOK)
+		rc = vfs_op_unlink(parentfd, expectfd, path);
+	
+	async_answer_0(rid, rc);
+}
+
+static void vfs_in_unmount(ipc_callid_t rid, ipc_call_t *request)
+{
+	int mpfd = IPC_GET_ARG1(*request);
+	int rc = vfs_op_unmount(mpfd);
+	async_answer_0(rid, rc);
+}
+
+static void vfs_in_wait_handle(ipc_callid_t rid, ipc_call_t *request)
+{
+	bool high_fd = IPC_GET_ARG1(*request);
+	int fd = vfs_op_wait_handle(high_fd);
+	async_answer_1(rid, EOK, fd);
+}
+
+static void vfs_in_walk(ipc_callid_t rid, ipc_call_t *request)
+{
+	/*
+	 * Parent is our relative root for file lookup.
+	 * For defined flags, see <ipc/vfs.h>.
+	 */
+	int parentfd = IPC_GET_ARG1(*request);
+	int flags = IPC_GET_ARG2(*request);
+	
+	int fd = 0;
+	char *path;
+	int rc = async_data_write_accept((void **)&path, true, 0, 0, 0, NULL);
+	if (rc == EOK) {
+		rc = vfs_op_walk(parentfd, flags, path, &fd);
+		free(path);
+	}
+	async_answer_1(rid, rc, fd);
+}
+
+static void vfs_in_write(ipc_callid_t rid, ipc_call_t *request)
+{
+	int fd = IPC_GET_ARG1(*request);
+	aoff64_t pos = MERGE_LOUP32(IPC_GET_ARG2(*request),
+	    IPC_GET_ARG3(*request));
+
+	size_t bytes = 0;
+	int rc = vfs_op_write(fd, pos, &bytes);
+	async_answer_1(rid, rc, bytes);
+}
+
+void vfs_connection(ipc_callid_t iid, ipc_call_t *icall, void *arg)
+{
+	bool cont = true;
+	
+	/*
+	 * The connection was opened via the IPC_CONNECT_ME_TO call.
+	 * This call needs to be answered.
+	 */
+	async_answer_0(iid, EOK);
+	
+	while (cont) {
+		ipc_call_t call;
+		ipc_callid_t callid = async_get_call(&call);
+		
+		if (!IPC_GET_IMETHOD(call))
+			break;
+		
+		switch (IPC_GET_IMETHOD(call)) {
+		case VFS_IN_CLONE:
+			vfs_in_clone(callid, &call);
+			break;
+		case VFS_IN_MOUNT:
+			vfs_in_mount(callid, &call);
+			break;
+		case VFS_IN_OPEN:
+			vfs_in_open(callid, &call);
+			break;
+		case VFS_IN_PUT:
+			vfs_in_put(callid, &call);
+			break;
+		case VFS_IN_READ:
+			vfs_in_read(callid, &call);
+			break;
+		case VFS_IN_REGISTER:
+			vfs_register(callid, &call);
+			cont = false;
+			break;
+		case VFS_IN_RENAME:
+			vfs_in_rename(callid, &call);
+			break;
+		case VFS_IN_RESIZE:
+			vfs_in_resize(callid, &call);
+			break;
+		case VFS_IN_STAT:
+			vfs_in_stat(callid, &call);
+			break;
+		case VFS_IN_STATFS:
+			vfs_in_statfs(callid, &call);
+			break;
+		case VFS_IN_SYNC:
+			vfs_in_sync(callid, &call);
+			break;
+		case VFS_IN_UNLINK:
+			vfs_in_unlink(callid, &call);
+			break;
+		case VFS_IN_UNMOUNT:
+			vfs_in_unmount(callid, &call);
+			break;
+		case VFS_IN_WAIT_HANDLE:
+			vfs_in_wait_handle(callid, &call);
+			break;
+		case VFS_IN_WALK:
+			vfs_in_walk(callid, &call);
+			break;
+		case VFS_IN_WRITE:
+			vfs_in_write(callid, &call);
+			break;
+		default:
+			async_answer_0(callid, ENOTSUP);
+			break;
+		}
+	}
+	
+	/*
+	 * Open files for this client will be cleaned up when its last
+	 * connection fibril terminates.
+	 */
+}
Index: uspace/srv/vfs/vfs_lookup.c
===================================================================
--- uspace/srv/vfs/vfs_lookup.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/srv/vfs/vfs_lookup.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -46,6 +46,6 @@
 #include <adt/list.h>
 #include <vfs/canonify.h>
-
-#define min(a, b)  ((a) < (b) ? (a) : (b))
+#include <dirent.h>
+#include <assert.h>
 
 FIBRIL_MUTEX_INITIALIZE(plb_mutex);
@@ -53,49 +53,11 @@
 uint8_t *plb = NULL;
 
-/** Perform a path lookup.
- *
- * @param path    Path to be resolved; it must be a NULL-terminated
- *                string.
- * @param lflag   Flags to be used during lookup.
- * @param result  Empty structure where the lookup result will be stored.
- *                Can be NULL.
- * @param altroot If non-empty, will be used instead of rootfs as the root
- *                of the whole VFS tree.
- *
- * @return EOK on success or an error code from errno.h.
- *
- */
-int vfs_lookup_internal(char *path, int lflag, vfs_lookup_res_t *result,
-    vfs_pair_t *altroot, ...)
-{
-	vfs_pair_t *root;
-
-	if (altroot)
-		root = altroot;
-	else
-		root = &rootfs;
-
-	if (!root->fs_handle)
-		return ENOENT;
-	
-	size_t len;
-	path = canonify(path, &len);
-	if (!path)
-		return EINVAL;
-	
-	fs_index_t index = 0;
-	if (lflag & L_LINK) {
-		va_list ap;
-
-		va_start(ap, altroot);
-		index = va_arg(ap, fs_index_t);
-		va_end(ap);
-	}
-	
+static int plb_insert_entry(plb_entry_t *entry, char *path, size_t *start,
+    size_t len)
+{
 	fibril_mutex_lock(&plb_mutex);
 
-	plb_entry_t entry;
-	link_initialize(&entry.plb_link);
-	entry.len = len;
+	link_initialize(&entry->plb_link);
+	entry->len = len;
 
 	size_t first;	/* the first free index */
@@ -138,6 +100,6 @@
 	 */
 
-	entry.index = first;
-	entry.len = len;
+	entry->index = first;
+	entry->len = len;
 
 	/*
@@ -145,5 +107,5 @@
 	 * buffer.
 	 */
-	list_append(&entry.plb_link, &plb_entries);
+	list_append(&entry->plb_link, &plb_entries);
 	
 	fibril_mutex_unlock(&plb_mutex);
@@ -158,45 +120,278 @@
 	memcpy(plb, &path[cnt1], cnt2);
 
-	ipc_call_t answer;
-	async_exch_t *exch = vfs_exchange_grab(root->fs_handle);
-	aid_t req = async_send_5(exch, VFS_OUT_LOOKUP, (sysarg_t) first,
-	    (sysarg_t) (first + len - 1) % PLB_SIZE,
-	    (sysarg_t) root->service_id, (sysarg_t) lflag, (sysarg_t) index,
-	    &answer);
-	
-	sysarg_t rc;
-	async_wait_for(req, &rc);
-	vfs_exchange_release(exch);
-	
+	*start = first;
+	return EOK;
+}
+
+static void plb_clear_entry(plb_entry_t *entry, size_t first, size_t len)
+{
 	fibril_mutex_lock(&plb_mutex);
-	list_remove(&entry.plb_link);
+	list_remove(&entry->plb_link);
 	/*
 	 * Erasing the path from PLB will come handy for debugging purposes.
 	 */
+	size_t cnt1 = min(len, (PLB_SIZE - first) + 1);
+	size_t cnt2 = len - cnt1;
 	memset(&plb[first], 0, cnt1);
 	memset(plb, 0, cnt2);
 	fibril_mutex_unlock(&plb_mutex);
-	
-	if ((int) rc < EOK)
+}
+
+int vfs_link_internal(vfs_node_t *base, char *path, vfs_triplet_t *child)
+{
+	assert(base != NULL);
+	assert(child != NULL);
+	assert(base->fs_handle);
+	assert(child->fs_handle);
+	assert(path != NULL);
+	
+	vfs_lookup_res_t res;
+	char component[NAME_MAX + 1];
+	int rc;
+	
+	size_t len;
+	char *npath = canonify(path, &len);
+	if (!npath) {
+		rc = EINVAL;
+		goto out;
+	}
+	path = npath;
+	
+	vfs_triplet_t *triplet;
+	
+	char *slash = str_rchr(path, L'/');
+	if (slash && slash != path) {
+		if (slash[1] == 0) {
+			rc = EINVAL;
+			goto out;
+		}
+		
+		memcpy(component, slash + 1, str_size(slash));
+		*slash = 0;
+		
+		rc = vfs_lookup_internal(base, path, L_DIRECTORY, &res);
+		if (rc != EOK)
+			goto out;
+		triplet = &res.triplet;
+		
+		*slash = '/';
+	} else {
+		if (base->mount != NULL) {
+			rc = EINVAL;
+			goto out;
+		}
+		
+		memcpy(component, path + 1, str_size(path));
+		triplet = (vfs_triplet_t *) base;
+	}
+	
+	if (triplet->fs_handle != child->fs_handle ||
+	    triplet->service_id != child->service_id) {
+		rc = EXDEV;
+		goto out;
+	}
+	
+	async_exch_t *exch = vfs_exchange_grab(triplet->fs_handle);
+	aid_t req = async_send_3(exch, VFS_OUT_LINK, triplet->service_id,
+	    triplet->index, child->index, NULL);
+	
+	rc = async_data_write_start(exch, component, str_size(component) + 1);
+	sysarg_t orig_rc;
+	async_wait_for(req, &orig_rc);
+	vfs_exchange_release(exch);
+	if (orig_rc != EOK)
+		rc = orig_rc;
+	
+out:
+	return rc;
+}
+
+static int out_lookup(vfs_triplet_t *base, size_t *pfirst, size_t *plen,
+    int lflag, vfs_lookup_res_t *result)
+{
+	assert(base);
+	assert(result);
+	
+	sysarg_t rc;
+	ipc_call_t answer;
+	async_exch_t *exch = vfs_exchange_grab(base->fs_handle);
+	aid_t req = async_send_5(exch, VFS_OUT_LOOKUP, (sysarg_t) *pfirst,
+	    (sysarg_t) *plen, (sysarg_t) base->service_id,
+	    (sysarg_t) base->index, (sysarg_t) lflag, &answer);
+	async_wait_for(req, &rc);
+	vfs_exchange_release(exch);
+	
+	if ((int) rc < 0)
 		return (int) rc;
-
-	if (!result)
-		return EOK;
+	
+	unsigned last = *pfirst + *plen;
+	*pfirst = IPC_GET_ARG3(answer) & 0xffff;
+	*plen = last - *pfirst;
 	
 	result->triplet.fs_handle = (fs_handle_t) rc;
 	result->triplet.service_id = (service_id_t) IPC_GET_ARG1(answer);
 	result->triplet.index = (fs_index_t) IPC_GET_ARG2(answer);
-	result->size =
-	    (aoff64_t) MERGE_LOUP32(IPC_GET_ARG3(answer), IPC_GET_ARG4(answer));
-	result->lnkcnt = (unsigned int) IPC_GET_ARG5(answer);
-	
-	if (lflag & L_FILE)
-		result->type = VFS_NODE_FILE;
-	else if (lflag & L_DIRECTORY)
-		result->type = VFS_NODE_DIRECTORY;
-	else
-		result->type = VFS_NODE_UNKNOWN;
-	
+	result->size = MERGE_LOUP32(IPC_GET_ARG4(answer), IPC_GET_ARG5(answer));
+	result->type = (IPC_GET_ARG3(answer) >> 16) ?
+	    VFS_NODE_DIRECTORY : VFS_NODE_FILE;
 	return EOK;
+}
+
+static int _vfs_lookup_internal(vfs_node_t *base, char *path, int lflag,
+    vfs_lookup_res_t *result, size_t len)
+{
+	size_t first;
+	int rc;
+
+	plb_entry_t entry;
+	rc = plb_insert_entry(&entry, path, &first, len);
+	if (rc != EOK)
+		return rc;
+	
+	size_t next = first;
+	size_t nlen = len;
+	
+	vfs_lookup_res_t res;
+	
+	/* Resolve path as long as there are mount points to cross. */
+	while (nlen > 0) {
+		while (base->mount) {
+			if (lflag & L_DISABLE_MOUNTS) {
+				rc = EXDEV;
+				goto out;
+			}
+			
+			base = base->mount;
+		}
+		
+		rc = out_lookup((vfs_triplet_t *) base, &next, &nlen, lflag,
+		    &res);
+		if (rc != EOK)
+			goto out;
+		
+		if (nlen > 0) {
+			base = vfs_node_peek(&res);
+			if (!base) {
+				rc = ENOENT;
+				goto out;
+			}
+	       		if (!base->mount) {
+				vfs_node_put(base);
+				rc = ENOENT;
+				goto out;
+			}
+			vfs_node_put(base);
+			if (lflag & L_DISABLE_MOUNTS) {
+				rc = EXDEV;
+				goto out;
+			}
+		}
+	}
+	
+	assert(nlen == 0);
+	rc = EOK;
+	
+	if (result != NULL) {
+		/* The found file may be a mount point. Try to cross it. */
+		if (!(lflag & (L_MP | L_DISABLE_MOUNTS))) {
+			base = vfs_node_peek(&res);
+			if (base && base->mount) {
+				while (base->mount) {
+					vfs_node_addref(base->mount);
+					vfs_node_t *nbase = base->mount;
+					vfs_node_put(base);
+					base = nbase;
+				}
+				
+				result->triplet = *((vfs_triplet_t *) base);
+				result->type = base->type;
+				result->size = base->size;
+				vfs_node_put(base);
+				goto out;
+			}
+			if (base)
+				vfs_node_put(base);
+		}
+
+		*result = res;
+	}
+	
+out:
+	plb_clear_entry(&entry, first, len);
+	return rc;
+}
+
+/** Perform a path lookup.
+ *
+ * @param base    The file from which to perform the lookup.
+ * @param path    Path to be resolved; it must be a NULL-terminated
+ *                string.
+ * @param lflag   Flags to be used during lookup.
+ * @param result  Empty structure where the lookup result will be stored.
+ *                Can be NULL.
+ *
+ * @return EOK on success or an error code from errno.h.
+ *
+ */
+int vfs_lookup_internal(vfs_node_t *base, char *path, int lflag,
+    vfs_lookup_res_t *result)
+{
+	assert(base != NULL);
+	assert(path != NULL);
+	
+	size_t len;
+	int rc;
+	char *npath = canonify(path, &len);
+	if (!npath) {
+		rc = EINVAL;
+		return rc;
+	}
+	path = npath;
+	
+	assert(path[0] == '/');
+
+
+	if (lflag & (L_CREATE | L_UNLINK)) {
+
+		/*
+		 * Creation and destruction of names must be done in two
+		 * separate steps: lookup of the parent node and the name
+		 * link/unlink operation itself.  Otherwise the parent
+		 * filesystem would not be able to tell when a mountpoint is
+		 * crossed. It would attempt to perform the link/unlink in
+		 * itself instead of letting the mounted filesystem do it,
+		 * resulting in wrong behavior. This is the wages of server-side
+		 * mountpoints.
+		 */
+
+		char *slash = str_rchr(path, L'/');
+		vfs_node_t *parent = base;
+		
+		if (slash != path) {
+			int tflag = lflag;
+			vfs_lookup_res_t tres;
+
+			tflag &= ~(L_CREATE | L_EXCLUSIVE | L_UNLINK | L_FILE);
+			tflag |= L_DIRECTORY;
+			rc = _vfs_lookup_internal(base, path, tflag, &tres,
+			    slash - path);
+			if (rc != EOK)
+				return rc;
+			parent = vfs_node_get(&tres);
+			if (!parent)
+				return ENOMEM;
+		} else
+			vfs_node_addref(parent);
+
+		rc = _vfs_lookup_internal(parent, slash, lflag, result,
+		    len - (slash - path));
+
+		vfs_node_put(parent);
+
+	} else {
+		rc = _vfs_lookup_internal(base, path, lflag, result, len);
+	}
+	
+	return rc;
 }
 
Index: uspace/srv/vfs/vfs_node.c
===================================================================
--- uspace/srv/vfs/vfs_node.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/srv/vfs/vfs_node.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -45,4 +45,5 @@
 #include <async.h>
 #include <errno.h>
+#include <macros.h>
 
 /** Mutex protecting the VFS node hash table. */
@@ -106,11 +107,10 @@
 void vfs_node_delref(vfs_node_t *node)
 {
-	bool free_vfs_node = false;
-	bool free_fs_node = false;
-	
-	fibril_mutex_lock(&nodes_mutex);
-	
-	if (node->refcnt-- == 1) {
-		
+	bool free_node = false;
+	
+	fibril_mutex_lock(&nodes_mutex);
+	
+	node->refcnt--;
+	if (node->refcnt == 0) {
 		/*
 		 * We are dropping the last reference to this node.
@@ -119,29 +119,22 @@
 		
 		hash_table_remove_item(&nodes, &node->nh_link);
-		free_vfs_node = true;
-		
-		if (!node->lnkcnt)
-			free_fs_node = true;
+		free_node = true;
 	}
 	
 	fibril_mutex_unlock(&nodes_mutex);
 	
-	if (free_fs_node) {
-		
+	if (free_node) {
 		/*
-		 * The node is not visible in the file system namespace.
-		 * Free up its resources.
+		 * VFS_OUT_DESTROY will free up the file's resources if there
+		 * are no more hard links.
 		 */
 		
 		async_exch_t *exch = vfs_exchange_grab(node->fs_handle);
-		sysarg_t rc = async_req_2_0(exch, VFS_OUT_DESTROY,
-		    (sysarg_t) node->service_id, (sysarg_t)node->index);
-		
-		assert(rc == EOK);
+		async_msg_2(exch, VFS_OUT_DESTROY, (sysarg_t) node->service_id,
+		    (sysarg_t)node->index);
 		vfs_exchange_release(exch);
+
+		free(node);
 	}
-	
-	if (free_vfs_node)
-		free(node);
 }
 
@@ -190,5 +183,4 @@
 		node->index = result->triplet.index;
 		node->size = result->size;
-		node->lnkcnt = result->lnkcnt;
 		node->type = result->type;
 		fibril_rwlock_initialize(&node->contents_rwlock);
@@ -196,16 +188,22 @@
 	} else {
 		node = hash_table_get_inst(tmp, vfs_node_t, nh_link);
-		if (node->type == VFS_NODE_UNKNOWN &&
-		    result->type != VFS_NODE_UNKNOWN) {
-			/* Upgrade the node type. */
-			node->type = result->type;
-		}
 	}
 
-	assert(node->size == result->size || node->type != VFS_NODE_FILE);
-	assert(node->lnkcnt == result->lnkcnt);
-	assert(node->type == result->type || result->type == VFS_NODE_UNKNOWN);
-
 	_vfs_node_addref(node);
+	fibril_mutex_unlock(&nodes_mutex);
+
+	return node;
+}
+
+vfs_node_t *vfs_node_peek(vfs_lookup_res_t *result)
+{
+	vfs_node_t *node = NULL;
+
+	fibril_mutex_lock(&nodes_mutex);
+	ht_link_t *tmp = hash_table_find(&nodes, &result->triplet);
+	if (tmp) {
+		node = hash_table_get_inst(tmp, vfs_node_t, nh_link);
+		_vfs_node_addref(node);
+	}
 	fibril_mutex_unlock(&nodes_mutex);
 
@@ -302,7 +300,6 @@
 	vfs_triplet_t *tri = key;
 	vfs_node_t *node = hash_table_get_inst(item, vfs_node_t, nh_link);
-	return node->fs_handle == tri->fs_handle 
-		&& node->service_id == tri->service_id
-		&& node->index == tri->index;
+	return node->fs_handle == tri->fs_handle &&
+	    node->service_id == tri->service_id && node->index == tri->index;
 }
 
@@ -318,4 +315,13 @@
 }
 
+bool vfs_node_has_children(vfs_node_t *node)
+{
+	async_exch_t *exch = vfs_exchange_grab(node->fs_handle);
+	int rc = async_req_2_0(exch, VFS_OUT_IS_EMPTY, node->service_id,
+	    node->index);
+	vfs_exchange_release(exch);
+	return rc == ENOTEMPTY;
+}
+
 /**
  * @}
